{% extends "base.html" %}
{% load static %}

{% block title %} {% if idMessage %}Edition {% else %} Creation {% endif %} {% endblock %}
{% block titleHeader %}{% if idMessage %}Edition {% else %} Creation {% endif %} {% endblock %}
{% block titleSubHeader %} {% if idMessage %}Edition of a message{% else %} Creation of a message {% endif %}  {% endblock %}

{% block libraries %}
<script src="https://cdn.jsdelivr.net/npm/@editorjs/editorjs@latest"></script>
<script src="https://cdn.jsdelivr.net/npm/codex.editor.header@2.0.4/dist/bundle.js"></script>
<script src="https://cdn.jsdelivr.net/npm/@editorjs/header@latest"></script><!-- Header -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/image@latest"></script><!-- Image -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/delimiter@latest"></script><!-- Delimiter -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/list@latest"></script><!-- List -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/checklist@latest"></script><!-- Checklist -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/quote@latest"></script><!-- Quote -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/code@latest"></script><!-- Code -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/embed@latest"></script><!-- Embed -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/table@latest"></script><!-- Table -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/link@latest"></script><!-- Link -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/warning@latest"></script><!-- Warning -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/code@latest"></script>
<script src="https://cdn.jsdelivr.net/npm/@editorjs/embed@latest"></script>


<script src="https://cdn.jsdelivr.net/npm/@editorjs/marker@latest"></script><!-- Marker -->
<script src="https://cdn.jsdelivr.net/npm/@editorjs/inline-code@latest"></script><!-- Inline Code -->

<script src="https://cdn.jsdelivr.net/npm/editorjs-html@3.4.0/build/edjsHTML.js"></script>

{% endblock %}

{% block content %}

<div class="container">
    <h1>{% if idMessage %}Edition of message : <code>#{{ idMessage }}</code> {% else %} Creation of a message {% endif %}</h1>
    <form method="POST">
        {% csrf_token %}
        {% for field in form %}
        <div class="mb-1 edit">
            {% if field.name != "messageDateCreation"  %}
            <p><b>{{ field.label }}{% if field.errors %} <span
                    style="color:red;">*</span> {% endif %}</b></p>
            {% if field.help_text %}
            <p class="helptext">{{ field.help_text|safe }}</p>
            {% endif %}
            {% endif %}
            {% if field.name == "messageContent" %}
            <div id="editorjs" name="messageContent"></div>
            <div class="d-none">
                {{ field }}
            </div>
            {% else %}
            {{ field }}
            {% endif %}
        </div>
        <br>
        {% endfor %}
        <div class="d-grid gap-2 d-md-flex justify-content-md-end">
            <a class="btn btn-danger" href="{% url 'home_page' %}" type="submit">Cancel</a>
            <button class="btn btn-primary" type="submit">Save</button>
        </div>
    </form>
</div>


<script>
    // EDITOR JS
    var False = false;
    var True = true;
    var None = ""
    var token = "{{ csrf_token }}"

    var editor = new EditorJS({
      /**
       * Wrapper of Editor
       */
      holder: 'editorjs',

      /**
       * Common Inline Toolbar settings
       * - if true (or not specified), the order from 'tool' property will be used
       * - if an array of tool names, this order will be used
       */
      // inlineToolbar: ['link', 'marker', 'bold', 'italic'],
      // inlineToolbar: true,

      /**
       * Tools list
       */
      tools: {
        /**
         * Each Tool is a Plugin. Pass them via 'class' option with necessary settings {@link docs/tools.md}
         */
        header: {
          class: Header,
          inlineToolbar: ['marker', 'link'],
          config: {
            placeholder: 'Header'
          },
          shortcut: 'CMD+SHIFT+H'
        },

        image: {
          class: ImageTool,
          config: {
            additionalRequestHeaders: {
                    "X-CSRF-TOKEN": token
            },
            endpoints: {
              byFile: '{% url "upload_img" method="byFile" %}', // Your backend file uploader endpoint
              byUrl: '{% url "upload_img" method="byUrl" %}', // Your endpoint that provides uploading by Url
            }
          }
        },

        list: {
          class: List,
          inlineToolbar: true,
          shortcut: 'CMD+SHIFT+L'
        },

        checklist: {
          class: Checklist,
          inlineToolbar: true,
        },
        embed: Embed,
        quote: {
          class: Quote,
          inlineToolbar: true,
          config: {
            quotePlaceholder: 'Enter a quote',
            captionPlaceholder: 'Quote\'s author',
          },
          shortcut: 'CMD+SHIFT+O'
        },

        warning: Warning,

        marker: {
          class:  Marker,
          shortcut: 'CMD+SHIFT+M'
        },

        code: {
          class:  CodeTool,
          shortcut: 'CMD+SHIFT+C'
        },

        delimiter: Delimiter,

        inlineCode: {
          class: InlineCode,
          shortcut: 'CMD+SHIFT+C'
        },

        embed: {
          class: Embed,
          inlineToolbar: true,
        },

        table: {
          class: Table,
          inlineToolbar: true,
          shortcut: 'CMD+ALT+T'
        },

      },

      {% if instance.messageContent %}
            data: {{ instance.messageContent| safe }},
        {% else %}
            data: {},
        {% endif %}



      onReady: function(){

      },
      onChange: function() {
        saved();
      }
    });
    function saved(){
        editor.save().then((savedData) => {
        console.log(JSON.stringify(savedData))
        document.getElementById('editorjs_textarea').innerHTML
                    = JSON.stringify(savedData);

        }).catch((error) => {
          console.log('Saving failed: ', error)
        });
    }
</script>
{% endblock %}

